'''A wrapper to make adding options to menus easy, different from easy menu in that it allows for parent menus with out ugly code'''

import popuplib

Menus = {}

def find(popupName):
    return create(popupName, Menus[popupName]['parent'])

def ClearMenus():
    for menu in Menus:
        delete(menu)

def delete(popupName):
    global Menus
    if popupName in Menus:
        while Menus[popupName]['pages'] > 0:
            popuplib.delete('%s %s'%(popupName, Menus[popupName]['pages']))
            Menus[popupName]['pages'] -= 1
        del Menus[popupName]

class create(object):
    def __init__(self, popupName, parentPopup, callBack=None):
        self.name = popupName
        if popupName not in Menus:
            Menus[popupName] = {'pages':1,
                                'options':0,
                                'title':None,
                                'callback':callBack,
                                'choices':{'page1':{}},
                                'parent':parentPopup}
            self.popup = popuplib.create('%s 1'%popupName)
            for i in range(12):
                self.popup.addline('')
            self.popup.modline(9, '-> 8. Back')
            self.name = popupName
            self.popup.submenu(8, parentPopup)
            self.popup.modline(11, '0. Exit')
            self.popup.menuselect = PopupSelect
        else:
            self.popup = popuplib.find('%s 1'%popupName)
        self.dict = Menus[popupName]
    def addoption(self, feedback, entry):
        self.dict['options'] += 1
        self.CheckPages()
        option = self.dict['options']-(7*(self.dict['pages']-1))
        self.dict['choices']['page%s'%self.dict['pages']][option] = feedback
        self.popup.modline(option+1, '-> %s. %s'%(option, entry))
    def addsubmenu(self, menuname, entry):
        self.dict['options'] += 1
        self.CheckPages()
        option = self.dict['options']-(7*(self.dict['pages']-1))
        self.dict['choices']['page%s'%self.dict['pages']][option] = 'submenu'
        self.popup.submenu(option, menuname)
        self.popup.modline(option+1, '-> %s. %s'%(option, entry))
    def settitle(self, title):
        self.dict['title'] = title
        pages = self.dict['pages']
        while pages > 0:
            popuplib.find('%s %s'%(self.name, pages)).modline(1, title)
            pages -= 1
    def CheckPages(self):
        self.dict['pages'] = (abs(self.dict['options']-1)/7)+1
        if not popuplib.exists('%s %s'%(self.name, self.dict['pages'])):
            self.popup.modline(10, '-> 9. Next')
            self.popup.submenu(9, '%s %s'%(self.name, self.dict['pages']))
            self.popup = popuplib.create('%s %s'%(self.name, self.dict['pages']))
            for i in range(11):
                self.popup.addline('')
            self.popup.modline(9, '-> 8. Back')
            self.popup.submenu(8, '%s %s'%(self.name, self.dict['pages']-1))
            self.popup.menuselect = PopupSelect
            self.dict['choices']['page%s'%self.dict['pages']] = {}
            if self.dict['title']:
                self.popup.modline(1, self.dict['title'])
    def send(self, userid):
        popuplib.find('%s 1'%self.name).send(userid)

def PopupSelect(userid, choice, popupid):
    if choice < 8:
        page = popupid.split(' ')[1]
        popupid = popupid.split(' ')[0]
        selection = Menus[popupid]['choices']['page%s'%page][choice]
        if selection != 'submenu':
            if Menus[popupid]['callback']:
                Menus[popupid]['callback'](userid, selection, popupid)
            else:
                es.dgbmsg(0, 'menulib Error: %s has no callback method'%popupid)
